In ancient China, people leverage I Ching to name their kids or predict their life.   

* [I Ching WiKi](https://en.wikipedia.org/wiki/I_Ching)
 
* [参考天涯问答:如何在三步之内学会用周易取名?](http://wenda.tianya.cn/question/1a6n72jk0djb6r76j7c93n6277ta0rcs8aj5k)
　
* 参考 熊逸 《周易江湖》(敝人很喜欢这位作者，他的《春秋大义》也相当不错)

* 在terminal运行： `python main.py`

* 会得到两个结果：第几爻和某一个卦象。在这个卦象里的第几爻便是最终结果。例如，我第一次测算时，得到的第5爻和乾卦（此乃真实故事）。那么乾卦的第5爻，即九二爻便是最终结果：飞龙在天，利见大人。


传统文化和现代生活已经有了很大的断层。现代人很少有懂得传统文化的，而起名公司或是一些所谓的大师高人，不是批批五行就是算算笔画，没多少正经东西。论《周易》的大师太多。我读书少，这篇取名三步法是根据熊逸的《周易江湖》总结而来。依此三步，定能取到一个合天地之灵气享易经之精华的好名字。

顺便再说几个起名的例子吧。
> 茶圣陆羽是个孤儿，自己给自己算卦起名字，算到了渐卦上九爻，所以姓取了“陆”，名取了“羽”，字取了“鸿渐”，完全取自“鸿渐于陆，其羽可用为仪”。

> 毛主席的名字也在《周易》里，《系辞》里说“是故刚柔相摩，八卦相荡，鼓之以雷霆，润之以风雨，”《说卦》里还有“雷以动之，风以散之，雨以润之”。名和字也是关联的，“泽东”而“润之”。

> 蒋介石的“名”是用《易经》里的爻辞——介石，“字”用相应的《易传》里的释文——中正，这也是古人起名字的一种传统。
　　
# 进入正题，进入起名之法。
## 第一步：心要诚，工具全 `iching.py`
* 首先，我们需要一本《周易》（《周易》=《易经》+《易传》）；
* 其次，取四十九根蓍草或其他（熊大师会用高档的玉石围棋子在精致的牛骨棋盘上演算，为了显示他很专业、很权威！如果你打算关了门自己算着玩，牙签和火柴棍也行。）
* 最后，心诚。如果在算卦之前能够沐浴焚香，可能会更为灵验。

## 第二步：时间充足，专心致志
每算一次，估约两小时左右（有了我的程序就很快了）。期间还要用到算数，如果有所差池，就要重新开始。

### 一、算卦开始 `calculate.py`

1. 把四十九颗棋子随机分成左右两组，象征着混沌初开，天与地一分为二。两组棋子，一组象征着天，一组象征着地。　　
2. 从任意一组当中拿掉一颗棋子（通常会从象征地的右边一组里拿），这颗棋子象征的就是人。天、地、人，称“三才”。
3. 把象征天的那组棋子数数有多少颗，数清楚之后把这个数字除以4（4象征一年四季），看看余数是几。任何数字除以4，余数都只有四种可能：1、2、3、整除。如果遇到整除的情况，我们就当做余数是4。好了，现在把余数拿开。
4. 把象征地的那组棋子照猫画虎，和“3”的做法一致。
5. 把“2”里用来象征人的那一颗棋子，加上“3”中作为余数被拿掉的棋子，还有“4”里同样作为余数被拿掉的棋子归在一起。得出的数字只有两种可能：不是9就是5。如果错了，你就从头再来吧。
　　
　好了，从1-5完成动作，叫做“一变”。

### 二、“二变”开始`change.py`
1. 把“一变”最后剩余的左右两组棋子重新混到一起，然后再随机分为两组。
2. 和“一变”的“2”一样。
3. 和“一变”的“3”一样。
4. 和“一变”的“4”一样。
5. 和“一变”的“5”一样。

完成后，只可能出现两种答案，4和8；如果不是，则一定是算错，请重来。

### 三、“三变”开始，方法同上

> 注意：这三道流程算完，最后的得数只有四种情况：24、28、32、36。无论得出这4个数字中得哪一个，都把这个数字除以4。

算出的结果，得出一个爻。（爻是卦的最基本的构成单位。）

此答案需记在纸上。（6、7、8、9四种结果之一）

### 四、把所有的49颗棋子重新归拢到一起，重复上述“三变”

一个完整的卦由6个爻组成。因此在算卦之时，耐心和时间尤为重要。

我们把六次算出的爻，由下向上分别记录。

## 第三步：分阴阳变谦卦，得答案`transfer.py`

假设，我们通过第二步算出的六个数字分别是：8、8、6、9、8、8。

### 一、我们先给“6、7、8、9”分阴阳
7、9都是奇数，为“阳”；6和8都是偶数，叫“阴”。不止这么简单，还需继续分：6是老阴，8是少阴，7是少阳，9是老阳。以四分法来看，这一卦是：“少阴、少阴、老阴、老阳、少阴、少阳”（8、8、6、9、8、8）。呈现“豫卦”。（卦象参考《周易》）

### 二、现在还需要在豫卦的基础上变出一个新卦
这就是谦卦。（遵循的原理：老变少不变）。此时，豫卦为本卦，谦卦为变卦。

有变卦也有变爻，原本豫卦里从下往上数的第三爻的数字是6，也就是少阴，变为阳爻；第四爻的数字是9，是老阳，变为阴爻。

## 演算到这里，得出了变卦和变爻，终于完成了整个占卜`main.py`

此时，我们可以用两个变爻的占辞来判断吉凶，定名字；并以位置考上的那一个变爻的占辞为主。参见《易经》，我们可以得到结果：“九四，由豫,大有得;勿疑,朋盍簪。”




